////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

void main()
{
    lowp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 overlay = texture2D(inputImageTexture2, textureCoordinate2);

    // 计算差值模式
    vec3 difference = abs(base.rgb - overlay.rgb);

    // 插值控制效果强度
    vec3 resultColor = mix(base.rgb, difference, 1.0);

    gl_FragColor = vec4(resultColor, base.a);



}