////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

float colorValue(float color1, float color2){
    float value = 0.0;
    if(color2 <= 0.5){
        value = min(color1,2.0 * color2);
    }else{
        value = max(color1,2.0 * color2 - 1.0);
    }
    return value;
}

void main()
{
    lowp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 overlay = texture2D(inputImageTexture2, textureCoordinate2);
    float r = colorValue(base.r, overlay.r);
    float g = colorValue(base.g, overlay.g);
    float b = colorValue(base.b, overlay.b);

    gl_FragColor = vec4(vec3(r, g, b), base.a);


}