////// Fragment Shader

//Luma转场1
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float power; // = 5.0
vec4 getFromColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture, uv);
    return imageColor;
}

vec4 getToColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture2, uv);
    return imageColor;
}


void main() {
    vec4 fTex = getFromColor(textureCoordinate);
    vec4 tTex = getToColor(textureCoordinate);
    float m = step(distance(fTex, tTex), progress);
    gl_FragColor = mix(
        mix(fTex, tTex, m),
        tTex,
        pow(progress, 5.0)
    );
}
