////// Fragment Shader

//回忆转场1
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;

vec4 getFromColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture, uv);
    return imageColor;
}

vec4 getToColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture2, uv);
    return imageColor;
}

vec2 offset(float progress, float x, float theta) {
    float phase = progress * progress + progress + theta;
    float shifty = 0.03 * progress * cos(10.0 * (progress + x));
    return vec2(0, shifty);
}

void main() {
    gl_FragColor = mix(getFromColor(textureCoordinate + offset(progress, textureCoordinate.x, 0.0)), getToColor(textureCoordinate + offset(1.0 - progress, textureCoordinate.x, 3.14)), progress);
}
