////// Fragment Shader

//中间打开转场
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform int type; // 0: 水平 1: 垂直

vec4 getFromColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture, uv);
    return imageColor;
}

vec4 getToColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture2, uv);
    return imageColor;
}


void main() {
    // 获取纹理坐标的 x 方向分量
    float judge = textureCoordinate.x;
    if(type == 1) {
        // 获取纹理坐标的 y 方向分量
        judge = textureCoordinate.y;
    }
    // 计算从中间往两边的过渡区域
    float mid = 0.5;
    float start = mid - progress / 2.0;
    float end = mid + progress / 2.0;

    // 调整平滑度的过渡效果
    float normalize = 0.005;
    float smoothStart = smoothstep(start - normalize, start, judge);
    float smoothEnd = smoothstep(end, end + normalize, judge);
    float transition = smoothStart - smoothEnd;

    // 从纹理1过渡到纹理2
    vec4 color1 = getFromColor(textureCoordinate);
    vec4 color2 = getToColor(textureCoordinate);
    vec4 finalColor = mix(color1, color2, transition);

    gl_FragColor = finalColor;
}