////// Fragment Shader

//窗格转场
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float count; // = 10.0
uniform float smoothness; // = 0.5
uniform float progress;

void main()
{
    float pr = smoothstep(-smoothness - 0.115, 0.12, textureCoordinate.x - progress * (1.0 + smoothness));
    float s = step(pr, fract(count * textureCoordinate.x));
    vec4 fromColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 toColor = texture2D(inputImageTexture2, textureCoordinate2);
    gl_FragColor = mix(fromColor, toColor, s);
}