////// Fragment Shader

//百叶窗转场
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform highp float move; //0.2
uniform highp float split; //5.0

vec4 getFromColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture, uv);
    return imageColor;
}

vec4 getToColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture2, uv);
    return imageColor;
}


void main() {
    // 获取 y 方向的坐标
    float y = textureCoordinate.y;

    // 计算当前像素所在的区间，区间范围为 [0, 4]
    float segment = floor(y * split); // 分成五个区域

    // 计算每个区域的起始和结束 y 坐标
    float segmentStart = segment / split;
    float segmentEnd = (segment + 1.0) / split;

    // 计算当前像素在区间内的相对位置
    float segmentPosition = mod((y - segmentStart) / (segmentEnd - segmentStart) + move, 1.0);

    // 计算每个区间的平滑过渡进度
    float smoothProgress = smoothstep(0.0, 0.1, (progress - segmentPosition) * split);

    // 获取纹理A和纹理B的颜色
    vec4 colorA = getFromColor(textureCoordinate);
    vec4 colorB = getToColor(textureCoordinate);

    // 根据当前区间的过渡进度计算最终颜色
    vec4 finalColor = mix(colorA, colorB, smoothProgress);

    gl_FragColor = finalColor;
}