////// Fragment Shader

//WaterDrop转场1
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float amplitude; // = 30
uniform float speed; // = 30
uniform highp vec2 inputSize;

vec4 getFromColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture, uv);
    return imageColor;
}

vec4 getToColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture2, uv);
    return imageColor;
}



void main() {
    float radio = inputSize.x / inputSize.y;
    vec2 radioFactor;
    if (radio >= 1.0) {
        radioFactor = vec2(radio, 1.0);
    } else {
        radioFactor = vec2(1.0, 1.0 / radio);
    }
    vec2 dir = textureCoordinate - vec2(.5);
    float dist = length(dir * radioFactor);
    if (dist > progress) {
        gl_FragColor = mix(getFromColor(textureCoordinate), getToColor(textureCoordinate), progress);
    } else {
        vec2 offset = dir * sin(dist * amplitude - progress * speed);
        gl_FragColor = mix(getFromColor(textureCoordinate + offset), getToColor(textureCoordinate), progress);
    }
}
