////// Fragment Shader

//风车转场
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float speed; // = 2.0;
uniform lowp float progress;
uniform bool reverse;

vec4 getFromColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture, uv);
    return imageColor;
}

vec4 getToColor(vec2 uv) {
    vec4 imageColor = texture2D(inputImageTexture2, uv);
    return imageColor;
}


void main()
{
    // 如果 reverse 为 true, 则将 progress 反向
    float direction = reverse ? -1.0 : 1.0;
    float circPos = atan(textureCoordinate.y - 0.5, textureCoordinate.x - 0.5) + progress * speed * direction;
    float modPos = mod(circPos, 3.1415 / 4.0);
    float signed = sign(progress * 0.8 - modPos);
    gl_FragColor = mix(getToColor(textureCoordinate), getFromColor(textureCoordinate), step(signed, 0.5));
}